#!/usr/bin/perl

#

#

# check_cpu.pl [warn] [critical]

# Nagios script to get the cpu usage from procinfo or sar

#

# Changes and Modification

# ========================

# 07-Oct-2003  - Benjamin Jakubowski

#   Adding check sar or procinfo command

# 07-Sept-2002 -  Benjamin Jakubowski

#   Created from check_cpu.pl for LDAP Serveur use 100% CPU

use Getopt::Long;
use vars qw($opt_h $verbose $opt_w $opt_c);

sub print_help ();

sub print_usage ();

$PROGNAME = "check_cpu";

$commande_sar=1;

$commande_procinfo=1;

$STATE_CRITICAL = 2;

$STATE_OK = 0;

$STATE_WARNING = 1;



if (! open(COM,'sar|') )

{

        #$error_sar = "System has not a command of 'sar',please install this command";
        $error_sar = "system_no_sar_command";

        $commande_sar=0;

}

else

{

        close COM;

}



if (! open(COM,'procinfo|') )

{

        #$error_procinfo="System has not a command of 'procinfo',please install this command";
        $error_procinfo="system_no_procinfo_command";

        $commande_procinfo=0;

}

else

{

       close COM;

}


Getopt::Long::Configure('bundling');
GetOptions ("h"   => \$opt_h, "help"       => \$opt_h,
        "v" => \$verbose, "verbose"  => \$verbose,
  "w=s" => \$opt_w, "warning=s"  => \$opt_w,
  "c=s" => \$opt_c, "critical=s" => \$opt_c);

if ($opt_h) {
  print_help();
  exit $ERRORS{'UNKNOWN'};
}

print_usage() unless (($opt_c) && ($opt_w));

my $cpu_critical;
my $cpu_warning;
($cpu_critical) = ($1,$2) if ($opt_c =~ /([0-9]+)[%]?(?:,([0-9]+)[%]?)?/);
($cpu_warning)  = ($1,$2) if ($opt_w =~ /([0-9]+)[%]?(?:,([0-9]+)[%]?)?/);


#if  ( @ARGV[0] eq "" || @ARGV[1] eq "" )

#{

#    print_usage ();

#    exit 0;

#}

#$warning = @ARGV[0];

#$critik = @ARGV[1];

if ( $commande_sar eq 0 && $commande_procinfo eq 0 )

{

    printf "$error_sar \n$error_procinfo\n";

    exit

    ;;

}



if  (  $commande_sar eq 1 && $commande_procinfo eq 1 )

{

	#modified by jiangtao.wu 1.10
    #$commande_sar=0;
    $commande_procinfo=0;

}

if ( $commande_procinfo eq 1 )

{

        @toto = `procinfo | grep idle | awk \'{print \$5}\'`;

        @cpu = 100-@toto[0];

}

if ( $commande_sar eq 1 )

{

        @line = `/usr/bin/sar 1 1 | /usr/bin/tail -n 2 | /usr/bin/head -n 1 | /bin/sed 's/\ \ */ /g'`;

        @data = split(/ /, @line[0]);

	$len=@data;

	@toto=@data[$len-1];

	@cpu=100-@toto[0];

}



if ( $cpu[0] >= $cpu_critical )

{

	#key-key
        printf ("CRITICAL: CPU Usage: %3.2f%|CPUUsed=%3.2f%;%d;%d \n",@cpu, @cpu,$cpu_warning,$cpu_critical);
        #printf ("service_cpu_critical#%3.2f%,%d,%d | CPUUsed=%3.2f%;%d;%d \n",@cpu, $cpu_warning, $cpu_critical, @cpu,$cpu_warning,$cpu_critical);

#        printf " idle : @toto%";

        exit $STATE_CRITICAL

        ;;

}



if (($cpu[0] < $cpu_critical)&&($cpu[0] < $cpu_warning))

{

	#key-key
        printf ("OK: CPU Usage: %3.2f%|CPUUsed=%3.2f%;%d;%d \n",@cpu, @cpu,$cpu_warning,$cpu_critical);
        #printf ("service_cpu_ok#%3.2f%,%d,%d | CPUUsed=%3.2f%;%d;%d \n",@cpu, $cpu_warning, $cpu_critical, @cpu,$cpu_warning,$cpu_critical);
        #printf ("service_cpu_ok#%3.2f%,%d,%d\n",@cpu, $cpu_warning,$cpu_critical);

 #       printf " idle : @toto%\n";

        exit $STATE_OK

        ;;

}

if (($cpu[0] >= $cpu_warning)&&($cpu[0] < $cpu_critical))

{

	#key-key
        printf ("WARNING: CPU Usage: %3.2f%|CPUUsed=%3.2f%;%d;%d \n",@cpu, @cpu,$cpu_warning,$cpu_critical);
        #printf ("service_cpu_warning#%3.2f%,%d,%d | CPUUsed=%3.2f%;%d;%d \n",@cpu, $cpu_warning, $cpu_critical, @cpu,$cpu_warning,$cpu_critical);
        #printf ("service_cpu_waring#%3.2f%,%d,%d\n",@cpu,$cpu_warning,$cpu_critical);

#        printf " idle : @toto%\n";

        exit $STATE_WARNING

        ;;

}





sub print_help ()

{

        print($PROGNAME,': 1.1');

        printf "\n";

        print "Copyright (c) 2002 Benjamin Jakubowski \

Perl Check CPU Usage plugin for Nagios \

";

}

sub print_usage ()

{

print_help();



printf "\n\nUsage : check_cpu.pl [-w warn] [-c critical]\n

warn, INTEGER

   Number of CPU Space at wich a warning will be generated ( No Default )

critical, INTEGER

   Number of CPU Space at wich a critical will be generated ( No Default )\n";

}


