#!/usr/bin/perl

# check_cpu.pl [warn] [critical]

# Nagios script to get the cpu usage from procinfo or sar


# Changes and Modification

# ========================

# 07-Oct-2003  - Benjamin Jakubowski

#   Adding check sar or procinfo command

# 07-Sept-2002 -  Benjamin Jakubowski

#   Created from check_cpu.pl for LDAP Serveur use 100% CPU

use Getopt::Long;
use vars qw($opt_h $verbose $opt_w $opt_c);


sub print_help ();

sub print_usage ();

$PROGNAME = "check_cpu_average";

$STATE_CRITICAL = 2;

$STATE_OK = 0;

$STATE_WARNING = 1;


if  ( @ARGV[0] eq "" || @ARGV[1] eq "" )

{

    print_usage ();

    exit 0;

}

Getopt::Long::Configure('bundling');
GetOptions ("h"   => \$opt_h, "help"       => \$opt_h,
        "v" => \$verbose, "verbose"  => \$verbose,
  "w=s" => \$opt_w, "warning=s"  => \$opt_w,
  "c=s" => \$opt_c, "critical=s" => \$opt_c);

if ($opt_h) {
  print_help();
  exit $ERRORS{'UNKNOWN'};
}

print_usage() unless (($opt_c) && ($opt_w));

my $cpu_critical;
my $cpu_warning;
($cpu_critical) = ($1,$2) if ($opt_c =~ /([0-9]+)[%]?(?:,([0-9]+)[%]?)?/);
($cpu_warning)  = ($1,$2) if ($opt_w =~ /([0-9]+)[%]?(?:,([0-9]+)[%]?)?/);

if ( -e "/var/log/check_cpu_average.out" )
{
    open in,"/var/log/check_cpu_average.out";

    if ( -z "/var/log/check_cpu_average.out" )
    {
        printf "service_cpu_average_warning_file_empty\n";
        exit $STATE_WARNING
        ;;
    }
    else
    {
        @cpu = <in>;
    }

    close in;
}
else
{
    printf "service_cpu_average_warning_file_isn't_exist\n";
    exit $STATE_WARNING

    ;;
}

#@cpu = (@data[2] + 0.5) +(@data[3])+(@data[2])+(@data[4]+0.5);


# add perfdata for cpu_5ave_useage by liuqing.cai 2012-02-03
if ( $cpu[0] >= $cpu_critical )

{

 #       printf ("CRITICAL: CPU Usage: %3.2f% \n",@cpu);
	#key-key
	#printf ("CRITICAL: CPU_5Ave_Usage: %3.2f%|CPU_5Ave_Used=%3.2f%;%d;%d\n",@cpu,@cpu,$cpu_warning,$cpu_critical);
 	printf ("service_cpu_average_critical#%3.2f%,%d,%d|CPU_5Ave_Used=%3.2f%;%d;%d\n",@cpu,$cpu_warning,$cpu_critical,@cpu,$cpu_warning,$cpu_critical);

#        printf " idle : @toto%";

        exit $STATE_CRITICAL

        ;;

}



if (($cpu[0] < $cpu_critical)&&($cpu[0] < $cpu_warning))

{
#	printf ("OK: CPU Usage: %3.2f% \n",@cpu);
	#key-key
 	#printf ("OK: CPU_5Ave_Usage: %3.2f%|CPU_5Ave_Used=%3.2f%;%d;%d\n",@cpu,@cpu,$cpu_warning,$cpu_critical);
 	printf ("service_cpu_average_ok#%3.2f%,%d,%d|CPU_5Ave_Used=%3.2f%;%d;%d\n",@cpu,$cpu_warning,$cpu_critical,@cpu,$cpu_warning,$cpu_critical);

 #       printf " idle : @toto%\n";
	exit $STATE_OK

        ;;

}

if (($cpu[0] >= $cpu_warning)&&($cpu[0] < $cpu_critical))

{

#        printf ("WARNING: CPU Usage: %3.2f% \n",@cpu);
	 #key-key
         #printf ("WARNING: CPU_5Ave_Usage: %3.2f%|CPU_5Ave_Used=%3.2f%;%d;%d\n",@cpu,@cpu,$cpu_warning,$cpu_critical);
 	printf ("service_cpu_average_warning#%3.2f%,%d,%d|CPU_5Ave_Used=%3.2f%;%d;%d\n",@cpu,$cpu_warning,$cpu_critical,@cpu,$cpu_warning,$cpu_critical);

#        printf " idle : @toto%\n";

        exit $STATE_WARNING

        ;;

}





sub print_help ()

{

        print($PROGNAME,': 1.1');

        printf "\n";

#        print "Copyright (c) 2002 Benjamin Jakubowski \

#Perl Check CPU Usage plugin for Nagios \

#";

}

sub print_usage ()

{

print_help();



printf "\n\nUsage : check_cpu.pl [-w warn] [-c critical]\n

warn, INTEGER

   Number of CPU Space at wich a warning will be generated ( No Default )

critical, INTEGER

   Number of CPU Space at wich a critical will be generated ( No Default )\n";

}


